package demogrpc

import (
	"google.golang.org/protobuf/types/known/timestamppb"

	pb "gitea.libretechconsulting.com/rmcguire/go-server-with-otel/api/demo/app/v1alpha1"
)

type RandomFact struct {
	ID        string `json:"id,omitempty"`
	Text      string `json:"text,omitempty"`
	Source    string `json:"source,omitempty"`
	SourceURL string `json:"source_url,omitempty"`
	Language  string `json:"language,omitempty"`
	Permalink string `json:"permalink,omitempty"`
}

func (f *RandomFact) FactToProto() *pb.GetDemoResponse {
	return &pb.GetDemoResponse{
		Timestamp: timestamppb.Now(),
		Fact:      f.Text,
		Source:    f.SourceURL,
		Language:  f.Language,
	}
}
